#! /usr/bin/env ruby

module NFS3Text
  TRACK_MAP = {
    'celtic' => 301,
    'landstrasse' => 302,
    'dolphin' => 303,
    'kindiak' => 304,
    'adonf' => 305,
    'durham' => 306,
    'snowy' => 307,
    'raceway' => 308, 'raceway1' => 308,
    'raceway2' => 309,
    'raceway3' => 310,

    'home' => 311, 'hometown' => 311,
    'redrock' => 312,
    'atlantica' => 313,
    'rocky' => 314,
    'country' => 315,
    'lost' => 316,
    'aquatica' => 317,
    'summit' => 318,
    'empire' => 319,
  }.freeze

  def self.read buf
    buf.force_encoding Encoding::ISO_8859_1
    n = buf.unpack1('V') / 4
    ary = buf[n*4..].split "\0", -1
    fail unless ary.pop.empty?
    fail unless ary.size == n
    ary
  end

  def self.write ary, io
    off = ary.size*4
    ofm = ary.map do |m|
      res = off
      off += m.bytesize + 1
      res
    end

    io.write ofm.pack 'V*'
    io.write ary.join "\0"
    io.write "\0"
  end
end

return unless __FILE__ == $0
require 'ap'

$stdin.binmode
ary = NFS3Text.read $stdin.read
ap ary.map {|x| x.encode Encoding::UTF_8 }
